<template>
        <div class='content-block'>
            <div class='container'>
                <div class='margin-top-50'></div>
                <div class='row'>
                    <div class='columns twelve loan-history'>
                        <h3 class='main-header full-table'>История займов</h3>
                        <div class='white-block'>
                            <div class='padding table-header'>
                                <div class='row'>
                                    <div :class="['columns', 'two', 'center', 'sum', {'top-arrow': sortOrder.num === 'ASC'}]"
                                         @click="runSort('num')">
                                        Тип заявки
                                    </div>
                                    <div :class="['columns', 'two', 'center', 'sum', {'top-arrow': sortOrder.dateFrom === 'ASC'}]"
                                         @click="runSort('dateFrom')">
                                        Дата начала
                                    </div>
                                    <div :class="['columns', 'two', 'center', 'sum', {'top-arrow': sortOrder.dateTo === 'ASC'}]"
                                         @click="runSort('dateTo')">
                                        Дата окончания
                                    </div>
                                    <div :class="['columns', 'two', 'center', 'sum', {'top-arrow': sortOrder.sum === 'ASC'}]"
                                         @click="runSort('sum')">
                                        Сумма
                                    </div>
                                    <div class='columns two center'>
                                        Документы
                                    </div>
                                    <div :class="['columns', 'two', 'center', 'sum', {'top-arrow': sortOrder.status === 'ASC'}]"
                                         @click="runSort('status', 'status')">
                                        Статус
                                    </div>
                                </div>
                            </div>
                            <hr/>
                            <div class="row mobile-table">
                                <div class="columns padding">
                                    <h3>История займов</h3>
                                </div>
                            </div>
                            <credit-list-row
                                    v-for='loan in loans'
                                    :loan='loan'
                                    :key="loan.id"
                                    class="list-item"/>

                        </div>
                        <div class='center' v-if="displayMoreButton">
                            <button class='white' @click="showMoreCredits">Показать ещё</button>
                        </div>
                    </div>
                    <!--<personal-stake-block></personal-stake-block>-->
                </div>
            </div>
            <docs-list/>
            <statements-list/>
        </div>
</template>

<script>
  import CreditListRow from './ListRow'
  import AjaxLoader from '@/base/Loader'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import DocsList from '@/components/Modals/DocsList'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import StatementsList from '@/components/Modals/StatementsList'

  export default {
    name: 'loan-history',
    data() {
      return {
        limit: 5,
        sortOrder: {
          num: 'ASC',
          dateFrom: 'ASC',
          dateTo: 'ASC',
          sum: 'ASC',
          status: 'ASC'
        }
      }
    },
    computed: {
      loans () {
        return this.$history.slice(0, this.limit)
      },
        displayMoreButton () {
          return !!(this.$history.length - this.limit > 0);
        }
    },
    mixins: [
      UserGetter,
      ErrorHandleMixin
    ],
    components: {
      StatementsList,
      DocsList,
      CreditListRow,
      AjaxLoader
    },
    methods: {
      runSort(type, mode = 'default') {
        if (this.loans.length <= 0) {
          return
        }
        /*
        В зависмости от типа сортировки определяем модификатор. Если сортировка по возрастанию, то модификатор 1.
        Если по убыванию - модификатор минус 1
         */
        const modificator = this.sortOrder[type] === 'ASC' ? 1 : -1
        /*
        Обычная функция сортировки. Применяется для сортирови по названию, дате и сумме займа
         */
        const defaultCompare = (a, b) => {
          if (a[type] > b[type]) {
            return modificator
          }
          if (a[type] < b[type]) {
            return -1 * modificator
          }
          return 0
        }
        /*
        Функция сортировки по статусу займа
         */
        const statusCompare = (a, b) => {
          let priorityA = this.getStatusPriority(a)
          let priorityB = this.getStatusPriority(b)
          if (priorityA > priorityB) {
            return modificator
          }
          if (priorityA < priorityB) {
            return -1 * modificator
          }
          return 0
        }
        /*
        Сортируем элементы
         */
        let compare = mode === 'status' ? statusCompare : defaultCompare
        this.loans.sort(compare)

        const objKeys = Object.keys(this.sortOrder)
        objKeys.forEach((value) => {
          if (value !== type) {
            // Обнуляем параметры сортировки для всех столбцов, кроме того, по которому проводим сортировку
            this.sortOrder[value] = 'ASC'
          }
        })
        // Для столбца, по которому производили сортировку, изменяем параметры сортировки
        this.sortOrder[type] = this.sortOrder[type] === 'ASC' ? 'DESC' : 'ASC'
      },
      getStatusPriority(obj) {
        let priority = 0
        switch (obj.statusGroup) {
          case 'approved':
            priority = 2
            break
          case 'wait':
            priority = 1
            break
          case 'canceled':
            priority = 0
            break
          default:
            priority = 0
        }
        return priority
      },
      showMoreCredits() {
        this.limit += 5;
      }
    }
  }
</script>

<style scoped lang="scss">
    div.sum {
        background: url("/lk/static/img/history/arrow.png") no-repeat 100% 5px;
        padding-right: 15px;
        cursor: pointer;
    }

    div.sum.top-arrow {
        background-position: 100% -90px
    }
</style>
